NDB_REDO_LOG_READER(1)

NAME
ndb_redo_log_reader - check and print content of cluster redo log

SYNOPSIS

ndb_redo_log_reader file_name [options]

DESCRIPTION

Reads a redo log file, checking it for errors, printing its contents in a human-readable format, or both. ndb_redo_log_reader is intended for use primarily by NDB Cluster developers and Support personnel in debugging and diagnosing problems.

This utility remains under development, and its syntax and behavior are subject to change in future NDB Cluster releases.

    Note

    Prior to NDB 7.2, this utility was named ndbd_redo_log_reader.

The C++ source files for ndb_redo_log_reader can be found in the directory /storage/ndb/src/kernel/blocks/dblqh/redoLogReader.

The following table includes options that are specific to the NDB Cluster program ndb_redo_log_reader. Additional descriptions follow the table. For options common to most NDB Cluster programs (including ndb_redo_log_reader), see Options Common to NDB Cluster Programs(1).

Table 21.344. Command-line options for the ndb_redo_log_reader program
Format | Description | Added, Deprecated, or Removed
-dump | Print dump info | All MySQL 5.7 based releases
-filedescriptors | Print file descriptors only | All MySQL 5.7 based releases
--help | Print usage information | All MySQL 5.7 based releases
-lap | Provide lap info, with max GCI started and completed | All MySQL 5.7 based releases
-mbyte # | Starting megabyte | All MySQL 5.7 based releases
-mbyteheaders | Show only the first page header of every megabyte in the file | All MySQL 5.7 based releases
-nocheck | Do not check records for errors | All MySQL 5.7 based releases
-noprint | Do not print records | All MySQL 5.7 based releases
-page # | Start with this page | All MySQL 5.7 based releases
-pageheaders | Show page headers only | All MySQL 5.7 based releases
-pageindex # | Start with this page index | All MySQL 5.7 based releases
-twiddle | Bit-shifted dump | All MySQL 5.7 based releases

Usage

    ndb_redo_log_reader file_name [options]

file_name is the name of a cluster redo log file. redo log files are located in the numbered directories under the data node's data directory (DataDir); the path under this directory to the redo log files matches the pattern ndb_nodeid_fs/D#/DBLQH/S#.FragLog. nodeid is the data node's node ID. The two instances of # each represent a number (not necessarily the same number); the number following D is in the range 8-39 inclusive; the range of the number following S varies according to the value of the NoOfFragmentLogFiles configuration parameter, whose default value is 16; thus, the default range of the number in the file name is 0-15 inclusive. For more information, see NDB Cluster Data Node File System Directory Files[1].

The name of the file to be read may be followed by one or more of the options listed here:

    • -dump
    Property | Value
    Command-Line Format | -dump
    Type | Boolean
    Default Value | FALSE

    Print dump info.

    •
    Property | Value
    Command-Line Format | -filedescriptors
    Type | Boolean
    Default Value | FALSE

    -filedescriptors: Print file descriptors only.

    •
    Property | Value
    Command-Line Format | --help

    --help: Print usage information.

    • -lap
    Property | Value
    Command-Line Format | -lap
    Type | Boolean
    Default Value | FALSE

    Provide lap info, with max GCI started and completed.

    •
    Property | Value
    Command-Line Format | -mbyte #
    Type | Numeric
    Default Value | 0
    Minimum Value | 0
    Maximum Value | 15

    -mbyte #: Starting megabyte.

    # is an integer in the range 0 to 15, inclusive.

    •
    Property | Value
    Command-Line Format | -mbyteheaders
    Type | Boolean
    Default Value | FALSE

    -mbyteheaders: Show only the first page header of every megabyte in the file.

    •
    Property | Value
    Command-Line Format | -noprint
    Type | Boolean
    Default Value | FALSE

    -noprint: Do not print the contents of the log file.

    •
    Property | Value
    Command-Line Format | -nocheck
    Type | Boolean
    Default Value | FALSE

    -nocheck: Do not check the log file for errors.

    •
    Property | Value
    Command-Line Format | -page #
    Type | Integer
    Default Value | 0
    Minimum Value | 0
    Maximum Value | 31

    -page #: Start at this page.

    # is an integer in the range 0 to 31, inclusive.

    •
    Property | Value
    Command-Line Format | -pageheaders
    Type | Boolean
    Default Value | FALSE

    -pageheaders: Show page headers only.

    •
    Property | Value
    Command-Line Format | -pageindex #
    Type | Integer
    Default Value | 12
    Minimum Value | 12
    Maximum Value | 8191

    -pageindex #: Start at this page index.

    # is an integer between 12 and 8191, inclusive.

    • -twiddle
    Property | Value
    Command-Line Format | -twiddle
    Type | Boolean
    Default Value | FALSE

    Bit-shifted dump.

Like ndb_print_backup_file and ndb_print_schema_file (and unlike most of the NDB utilities that are intended to be run on a management server host or to connect to a management server) ndb_redo_log_reader must be run on a cluster data node, since it accesses the data node file system directly. Because it does not make use of the management server, this utility can be used when the management server is not running, and even when the cluster has been completely shut down.

COPYRIGHT

Copyright © 1997, 2018, Oracle and/or its affiliates. All rights reserved.

This documentation is free software; you can redistribute it and/or modify it only under the terms of the GNU General Public License as published by the Free Software Foundation; version 2 of the License.

This documentation is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with the program; if not, write to the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA or see http://www.gnu.org/licenses/.

NOTES

1.  NDB Cluster Data Node File System Directory Files
    http://dev.mysql.com/doc/ndb-internals/en/ndb-internals-ndbd-filesystemdir-files.html

SEE ALSO
For more information, please refer to the MySQL Reference Manual, which may already be installed locally and which is also available online at http://dev.mysql.com/doc/.

AUTHOR
Oracle Corporation (http://dev.mysql.com/).